<template lang="html">
	<Page>
		<ActionBar title="Home" />
		<StackLayout>
			<Tabs>
				<TabStrip>
					<TabStripItem>
						<Label text="Favoritos"></Label>
						<Image src.decode="font://&#xf005;" class="fas t-36"></Image>
					</TabStripItem>
					<TabStripItem>
						<Label text="Buscar"></Label>
						<Image src.decode="font://&#xf002;" class="fas t-36"></Image>
					</TabStripItem>
					<TabStripItem>
						<Label text="Ubicación"></Label>
						<Image src.decode="font://&#xf3c5;" class="fas t-36"></Image>
					</TabStripItem>
				</TabStrip>
				<!-- Favoritos -->
				<TabContentItem>
					<ListView for="item in items" @itemTap="onItemTap">
						<v-template>
							<StackLayout orientation="horizontal">
								<Label>
									{{item.city_name}} -- {{item.temp}}
								</Label>
							</StackLayout>
						</v-template>
					</ListView>
				</TabContentItem>
				<!-- Buscador -->
				<TabContentItem>
					<StackLayout orientation="vertical" >
						<ListPicker :items="listOfItems" v-model="selectedItem" />
						<Button text="Buscar" @tap="onSearchTap" />
						<StackLayout orientation="horizontal">
							<Label v-if="city_weather">
								{{city_weather.city_name}} -- {{city_weather.temp}}
							</Label>
							<Button v-if="city_weather" text="Favorito" @tap="onFavoriteTap" />
						</StackLayout>
					</StackLayout>
				</TabContentItem>
				<!-- Ubicacion -->
				<TabContentItem>
					<StackLayout orientation="vertical">
						<StackLayout class="home-panel">
							<Label text="UBICACION DISPOSITIVO" />
							<Label :text="'Latitude = ' + device_geolocation.latitude" />
							<Label :text="'Longitude=' + device_geolocation.longitude" />
							<Button text="Buscar" @tap="fetchCityLocation" />

							<Label v-if="city_weather_location" :text="'Ciudad: ' + city_weather_location.city_name" />
							<Label v-if="city_weather_location" :text="'TEMPERATURA: ' + city_weather_location.temp" />
						</StackLayout>
					</StackLayout>
				</TabContentItem>
			</Tabs>
		</StackLayout>
	</Page>
</template>

<script>
import * as permissions from 'nativescript-permissions';
import * as platform from 'platform';

import * as geolocation from "nativescript-geolocation";
import { Accuracy } from "ui/enums";

export default {
	data: () => {
		return {
			items: [
							{
								city_name: "Cuidad 1",
								temp: "Temperatura Ciudad 1"
							}
			],
			listOfItems: [
										"La Plata",
										"Berisso",
										"Ensenada",
										"Magdalena",
                    "Buenos Aires",
                    "Brandsen"
                	],
			selectedItem: 0,
			city_weather: false,
			device_geolocation: {},
			city_weather_location: false,
		}
	},

	created() {
  	/* dont run the android permissions routine for iOS */
		if (platform.isIOS) {
			this.allowExecution = true;
			return;
		}
		/* list of permissions needed */
		let permissionsNeeded = [
			android.Manifest.permission.ACCESS_FINE_LOCATION,
			android.Manifest.permission.ACCESS_COARSE_LOCATION
		];
		/* showing up permissions dialog */
		permissions
			.requestPermissions(permissionsNeeded, "Give me permissions!")
			.then(() => this.allowExecution = true)
			.catch(() => this.allowExecution = false);
		
		this.fetchMyLocation()
	},

	methods: {
		onSearchTap() {
			const city = this.listOfItems[this.selectedItem];
			console.log('Button was pressed with: ' + city);

			fetch("https://api.weatherbit.io/v2.0/current?city=" + city + ",AR&key=c0dd30fbc6664b599d90f43328e86db4")
				.then((response) => {
					this.city_weather = JSON.parse(response._bodyInit).data[0]
				})
				.catch((err) => {
					alert({
						title: "Búsqueda",
						message: "Verifique su conexión",
						okButtonText: "OK"
					})
				});
		},

		onFavoriteTap(){
			console.log('Favorite was pressed with: ' + this.city_weather.city_name)
			this.items.push(this.city_weather)
			alert({
				title: "Favoritos",
				message: "Cuidad agregada exitosamente",
				okButtonText: "OK"
			})
			this.city_weather = false
		},

		// FIXME
		// onItemTap (event) {
  	// 	console.log("item: " + event.item.city_name)
		// 	console.log('Navegando hacias componentes misteriosos..')

		// 	this.$navigateTo(ItemDetails, {
		// 	  props: { 
		// 	    item: event.item
		// 		}
		// 	});
		// },

		fetchMyLocation() {
			geolocation
				.getCurrentLocation({
					desiredAccuracy: Accuracy.high,
					maximumAge: 1000,
					timeout: 20000
				})
				.then(res => {
					console.log('Obtuve geolocalizacion: lat-' + res.latitude + ' lon-'+ res.longitude)
					this.device_geolocation = res
				})
				.catch(e => {
					console.log("error", e);
				});
		},

		fetchCityLocation() {
 		  console.log('Buscando....  lat=' + this.device_geolocation.latitude + 'lon=' + this.device_geolocation.longitude)
			fetch("https://api.weatherbit.io/v2.0/current?lat=" + this.device_geolocation.latitude + "&lon=" + this.device_geolocation.longitude + "&key=c0dd30fbc6664b599d90f43328e86db4")
				.then((response) => {
					console.log('Encontre esto: ' + response._bodyInit )
					this.city_weather_location = JSON.parse(response._bodyInit).data[0]
				})
				.catch((err) => {
					alert({
						title: "Búsqueda",
						message: "Verifique su conexión",
						okButtonText: "OK"
					})
				});
		}
  },
}
</script>

<style lang="scss" scoped>
// Start custom common variables
@import "~@nativescript/theme/scss/variables/blue";
// End custom common variables

// Custom styles
	.home-panel {
    text-align: center;
    font-size: 17;
    margin-top: 20;
		margin-bottom: 10;
  }
</style>